﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="MultiListBox.ascx.cs" Inherits="AjaxListBox.Controls.MultiListBox" %>


<div style="float: left">
    <asp:Label ID="lblTitleLeft" runat="server" Text="Left Title" Font-Bold="true" Style="text-align:center" />
    </br>
    <asp:ListBox ID="ListBoxLeft" runat="server" Height="365px" SelectionMode="Multiple" CssClass="LeftBox"
        Width="300px"></asp:ListBox>
</div>

<div style="margin: 5px; float: left;">
    <asp:ImageButton ID="rightArr" ImageUrl="images/rightArrow.png" runat="server" ImageAlign="AbsMiddle" CssClass="RightArr" CausesValidation="false"/>
</div>

<div style="margin: 5px; float: left">
    <asp:ImageButton ID="leftArr" ImageUrl="images/leftArrow.png" runat="server" ImageAlign="AbsMiddle" CssClass="LeftArr" CausesValidation="false" />
</div>

<div>
    <asp:Label ID="lblTitleRight" runat="server" Text="Right Title" Font-Bold="true" Style="text-align: center" />
    </br>
    <asp:ListBox ID="ListBoxRight" runat="server" Height="365px" SelectionMode="Multiple" CssClass="RightBox"
        Width="300px"></asp:ListBox>
</div>

<div class="growlUI" style="display: none">
    <h1>Your Action is Successfully Saved.</h1>
    <h2>Thanks.</h2>
</div>

<input type="hidden" runat="server" id="hdnRightClickFunction" class="hdnRClick" />
<input type="hidden" runat="server" id="hdnLeftClickFunction" class="hdnLClick" />
<input type="hidden" runat="server" id="hdnLeftClickExtraData" value="" class="hdnLData" />
<input type="hidden" runat="server" id="hdnRightClickExtraData" value="" class="hdnRData" />


<script src="../Scripts/jquery.blockUI.js" type="text/javascript"></script>
<script src="../Scripts/json2.js" type="text/javascript"></script>
<script type="text/javascript">
    $(document).ready(function () {
        $('.RightArr').click(function () {
            TriggerRightClick();
            return false;
        });
        $('.LeftArr').click(function () {
            TriggerLeftClick();
            return false;
        });
    });

    function TriggerLeftClick() {
        var list = [];
        $('.RightBox :selected').each(function (i, selected) {

            $('.LeftBox').append('<option value=\"' + $(selected).val() + '\">' + $(selected).text() + '</option>');

            $(selected).remove();

            var item = {}
            item.selectedValue = $(selected).val();
            item.extraData = $("#" + $(".hdnLData").val()).val();
            list.push(item);
        });
        if (list.length == 0)
            return false;

        var url = $(".hdnLClick").val();
        CallServer(url, list);
    }

    function TriggerRightClick() {
        var list = [];
        $('.LeftBox :selected').each(function (i, selected) {

            $('.RightBox').append('<option value=\"' + $(selected).val() + '\">' + $(selected).text() + '</option>');

            $(selected).remove();

            var item = {}
            item.selectedValue = $(selected).val();
            item.extraData = $("#" + $(".hdnRData").val()).val();
            list.push(item);
        });
        if (list.length == 0)
            return false;

        var url = $(".hdnRClick").val();
        CallServer(url, list);
    }

    function CallServer(url, items) {
        $.ajax({
            type: "POST",
            url: url,
            cache: false,
            data: "{items:'" + JSON.stringify(items) + "'}",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (msg) {
                ShowNotification(msg.d);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                ShowNotification(xhr.responseText);
            }
        });
    }

    function ShowNotification(msg) {
        try {
            // Display a Notification to the user  //
            $(".growlUI h1").html(msg);
            $.blockUI({
                message: $('div.growlUI'),
                fadeIn: 700,
                fadeOut: 700,
                timeout: 3000,
                showOverlay: false,
                centerY: false,
                css: {
                    width: '350px',
                    top: $(window).height() - 150,
                    left: '',
                    right: '10px',
                    border: 'none',
                    padding: '2px',
                    backgroundColor: '#000',
                    '-webkit-border-radius': '10px',
                    '-moz-border-radius': '10px',
                    opacity: .7,
                    color: '#fff'
                }
            });
        }
        catch (ex) {
            //alert('This control requires the jquery.blockUI for notifications');
        }
    }
</script>